set(PASTIX_VERSION 6.2.2)

# relocatable package

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was PASTIXConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

set_and_check(PASTIX_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin/")
set_and_check(PASTIX_INC_DIR "${PACKAGE_PREFIX_DIR}/include/")
set_and_check(PASTIX_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib/")

check_required_components(PASTIX)

# need MORSE Find modules: necessary files must be distributed in the install path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/find")

# dependencies of PASTIX
include(CMakeFindDependencyMacro)

# Math libraries
find_dependency(M)
find_dependency(CBLAS REQUIRED)
find_dependency(LAPACKE REQUIRED)

# HwLoc libraries
if (TRUE)
  find_dependency(HWLOC REQUIRED)
endif()

# MPI library
if (OFF)
  find_dependency(MPI REQUIRED)
endif()

# GPU libraries
if (OFF)
  find_dependency(CUDA REQUIRED)
  include("${CMAKE_CURRENT_LIST_DIR}/pastix_kernels_cudaTargets.cmake")
endif()

# Runtime libraries
if (OFF)
  find_dependency(PARSEC REQUIRED)
endif()
if (ON)
  find_package(STARPU 1.3 REQUIRED)
endif()

# Ordering libraries
if (ON)
  find_dependency(SCOTCH REQUIRED)
endif()
if (OFF)
  find_dependency(PTSCOTCH REQUIRED)
endif()
if (ON)
  find_dependency(METIS REQUIRED)
endif()

# add the targets file
if ( FALSE )
  find_dependency( SPM REQUIRED )
else()
  include("${CMAKE_CURRENT_LIST_DIR}/../spm/spmTargets.cmake")
  if (ON)
    include("${CMAKE_CURRENT_LIST_DIR}/../spm/spmfTargets.cmake")
  endif()
endif()

include("${CMAKE_CURRENT_LIST_DIR}/pastix_kernelsTargets.cmake")
if (OFF)
  include("${CMAKE_CURRENT_LIST_DIR}/pastix_parsecTargets.cmake")
endif()
if (ON)
  include("${CMAKE_CURRENT_LIST_DIR}/pastix_starpuTargets.cmake")
endif()

include("${CMAKE_CURRENT_LIST_DIR}/pastixTargets.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/pastixfTargets.cmake")
