"""

 @file enum.py

 PaStiX python wrapper to define enums and datatypes

 @copyright 2017-2022 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.2.0
 @author Pierre Ramet
 @author Mathieu Faverge
 @author Tony Delarue
 @author Esragul Korkmaz
 @author Selmane Lebdaoui
 @date 2021-04-07

 This file has been automatically generated with gen_wrappers.py

 @ingroup wrap_python

"""
from ctypes import *
import numpy as np

# Start with __ to prevent broadcast to file importing enum
__pastix_int__ = c_int
__pastix_mpi_enabled__ = 0

class iparm:
    verbose                        = 0
    io_strategy                    = 1
    nnzeros                        = 2
    nnzeros_block_local            = 3
    allocated_terms                = 4
    produce_stats                  = 5
    mc64                           = 6
    ordering                       = 7
    ordering_default               = 8
    scotch_mt                      = 9
    scotch_switch_level            = 10
    scotch_cmin                    = 11
    scotch_cmax                    = 12
    scotch_frat                    = 13
    metis_ctype                    = 14
    metis_rtype                    = 15
    metis_no2hop                   = 16
    metis_nseps                    = 17
    metis_niter                    = 18
    metis_ufactor                  = 19
    metis_compress                 = 20
    metis_ccorder                  = 21
    metis_pfactor                  = 22
    metis_seed                     = 23
    metis_dbglvl                   = 24
    amalgamation_lvlblas           = 25
    amalgamation_lvlcblk           = 26
    reordering_split               = 27
    reordering_stop                = 28
    splitting_strategy             = 29
    splitting_levels_projections   = 30
    splitting_levels_kway          = 31
    splitting_projections_depth    = 32
    splitting_projections_distance = 33
    splitting_projections_width    = 34
    min_blocksize                  = 35
    max_blocksize                  = 36
    tasks2d_level                  = 37
    tasks2d_width                  = 38
    allcand                        = 39
    incomplete                     = 40
    level_of_fill                  = 41
    factorization                  = 42
    static_pivoting                = 43
    free_cscuser                   = 44
    schur_fact_mode                = 45
    transpose_solve                = 46
    schur_solv_mode                = 47
    applyperm_ws                   = 48
    refinement                     = 49
    nbiter                         = 50
    itermax                        = 51
    gmres_im                       = 52
    scheduler                      = 53
    thread_nbr                     = 54
    autosplit_comm                 = 55
    gpu_nbr                        = 56
    gpu_memory_percentage          = 57
    gpu_memory_block_size          = 58
    compress_min_width             = 59
    compress_min_height            = 60
    compress_when                  = 61
    compress_method                = 62
    compress_ortho                 = 63
    compress_reltol                = 64
    compress_preselect             = 65
    compress_iluk                  = 66
    mpi_thread_level               = 67
    modify_parameter               = 68
    start_task                     = 69
    end_task                       = 70
    float                          = 71
    mtx_type                       = 72
    dof_nbr                        = 73
    size                           = 74

class dparm:
    fill_in            = 0
    epsilon_refinement = 1
    relative_error     = 2
    epsilon_magn_ctrl  = 3
    order_time         = 4
    symbfact_time      = 5
    reorder_time       = 6
    blend_time         = 7
    analyze_time       = 8
    pred_fact_time     = 9
    fact_time          = 10
    fact_flops         = 11
    fact_thflops       = 12
    fact_rlflops       = 13
    solv_time          = 14
    solv_flops         = 15
    solv_thflops       = 16
    solv_rlflops       = 17
    refine_time        = 18
    a_norm             = 19
    compress_tolerance = 20
    compress_min_ratio = 21
    size               = 22

class task:
    Init     = 0
    Ordering = 1
    Symbfact = 2
    Analyze  = 3
    Numfact  = 4
    Solve    = 5
    Refine   = 6
    Clean    = 7

class verbose:
    Not = 0
    No  = 1
    Yes = 2

class io:
    No        = 0
    Load      = 1
    Save      = 2
    LoadGraph = 4
    SaveGraph = 8
    LoadCSC   = 16
    SaveCSC   = 32

class fact_mode:
    Local = 0
    Schur = 1
    Both  = 2

class solv_mode:
    Local     = 0
    Interface = 1
    Schur     = 2

class refine:
    GMRES    = 0
    CG       = 1
    SR       = 2
    BiCGSTAB = 3

class factotype:
    POTRF = 0
    SYTRF = 1
    GETRF = 2
    PXTRF = 3
    HETRF = 4
    LLH   = 0
    LDLT  = 1
    LU    = 2
    LLT   = 3
    LDLH  = 4

class scheduler:
    Sequential = 0
    Static     = 1
    Parsec     = 2
    StarPU     = 3
    Dynamic    = 4

class ordering:
    Scotch   = 0
    Metis    = 1
    Personal = 2
    PtScotch = 3
    ParMetis = 4

class mpithreadmode:
    MpiNone             = 0
    MpiThreadSingle     = 1
    MpiThreadFunneled   = 2
    MpiThreadSerialized = 3
    MpiThreadMultiple   = 4

class error:
    SUCCESS        = 0
    UNKNOWN        = 1
    ALLOC          = 2
    NOTIMPLEMENTED = 3
    OUTOFMEMORY    = 4
    THREAD         = 5
    INTERNAL       = 6
    BADPARAMETER   = 7
    FILE           = 8
    INTEGER_TYPE   = 9
    IO             = 10
    MPI            = 11

class compress_when:
    Never  = 0
    Begin  = 1
    End    = 2
    During = 3

class compress_method:
    SVD   = 0
    PQRCP = 1
    RQRCP = 2
    TQRCP = 3
    RQRRT = 4
    Nbr   = 5

class compress_ortho:
    OrthoCGS       = 0
    OrthoQR        = 1
    OrthoPartialQR = 2

class split:
    Not             = 0
    Kway            = 1
    KwayProjections = 2

class layout:
    RowMajor = 101
    ColMajor = 102

class trans:
    NoTrans   = 111
    Trans     = 112
    ConjTrans = 113

class mtxtype:
    General   = trans.NoTrans
    Symmetric = trans.Trans
    Hermitian = trans.ConjTrans
    SymPosDef = trans.ConjTrans + 1
    HerPosDef = trans.ConjTrans + 2

class uplo:
    Upper      = 121
    Lower      = 122
    UpperLower = 123

class coefside:
    LCoef  = 0
    UCoef  = 1
    LUCoef = 2

class diag:
    NonUnit = 131
    Unit    = 132

class side:
    Left  = 141
    Right = 142

class normtype:
    One       = 171
    Frobenius = 174
    Inf       = 175
    Max       = 177

class dir:
    Forward  = 391
    Backward = 392


